//////////////////////////////////////////////////////////////////////////////
//
//    RENAMEIMAGESDIALOG.H
//
//    Copyright (C) 2003 Gilles CAULIER <caulier dot gilles at free.fr>
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////


#ifndef RENAMEIMAGESDIALOG_H
#define RENAMEIMAGESDIALOG_H

// Include files for Qt

#include <qstring.h>

// Include files for KDE

#include <kdialogbase.h>
#include <kio/job.h>

#define SORT_BY_NAME 0
#define SORT_BY_SIZE 1
#define SORT_BY_DATE 3

class QLabel;
class QCheckBox;
class QComboBox;
class QPushButton;
class QFileInfo;
class QListViewItemIterator;

class KConfig;
class KProgress;
class KListView;
class KIntSpinBox;
class KLineEdit;

class RenameImagesDialog : public KDialogBase
{
Q_OBJECT

 public:
   RenameImagesDialog(QWidget *parent=0, QStringList filesList=0);
   ~RenameImagesDialog();

 private slots:
   void slotAbout(void);
   void slotRename(void);
   void slotOk();
   void slotTemplateSortListChanged(const QString &text);
   void slotTemplateSortListChanged(int index);
   void slotTemplateSortListChanged(bool on);
   void slotAddNewAlbum( void );
   void slot_onAlbumCreate( KIO::Job* job );
   void slotResult( KIO::Job *job );
   void slotAlbumChanged(const QString &albumName);

 protected:
   QLabel          *m_labelPrefix;
   QLabel          *m_labelStart;
   QLabel          *m_labelSort;
   QLabel          *m_statusbar;

   KLineEdit       *m_prefix;
   KIntSpinBox     *m_enumeratorStart;

   QCheckBox       *m_addOriginalFileName;
   QCheckBox       *m_addImageFileDate;
   QCheckBox       *m_addImageFileSize;
   QCheckBox       *m_deleteOrignalFiles;
   QCheckBox       *m_reverseOrder;

   QComboBox       *m_sortList;
   QComboBox       *m_albumList;

   KListView       *m_listFiles;
   QPushButton     *m_addNewAlbumButton;
   KProgress       *m_progress;

   KConfig         *m_config;
   bool             m_cancelled;
   QStringList      m_selectedImageFiles;
   QString          m_newDir;
   int              m_nbItem;
   int              m_progressStatus;

   QListViewItemIterator *m_filelist_it;

   void sortingImageFiles(void);
   int sortType(void);
   QString oldFileName2NewFileName(QFileInfo *fi, int id);
   void copyItemOperations(void);
};

#endif  // RENAMEIMAGESDIALOG_H
