//////////////////////////////////////////////////////////////////////////////
//
//    RESIZEIMAGESDIALOG.H
//
//    Copyright (C) 2004 Gilles CAULIER <caulier dot gilles at free.fr>
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////


#ifndef RESIZEIMAGESDIALOG_H
#define RESIZEIMAGESDIALOG_H

#define OVERWRITE_ASK    0
#define OVERWRITE_RENAME 1
#define OVERWRITE_SKIP   2
#define OVERWRITE_OVER   3

#define NO_PROCESS       0
#define UNDER_PROCESS    1
#define PROCESS_DONE     2
#define STOP_PROCESS     3

// Include files for Qt

#include <qstring.h>
#include <kdialogbase.h>

// Include files for KDE

#include <kio/job.h>

class QLabel;
class QComboBox;
class QCheckBox;
class QPushButton;
class QListViewItemIterator;
class QFileInfo;
class QListViewItem;

class KProcess;
class KConfig;
class KProgress;
class KListView;

class ResizeImagesDialog : public KDialogBase
{
Q_OBJECT

 public:
   ResizeImagesDialog(QWidget *parent=0, QStringList filesList=0);
   ~ResizeImagesDialog();

 private slots:
   void slotAbout(void);
   void slotProcessStart(void);
   void slotOk();
   void slotStop();
   void ProcessDone(KProcess* proc);
   void slotListDoubleClicked(QListViewItem *itemClicked);
   void slotOptionsFileFormatClicked(void);
   void slotReadStd(KProcess* proc, char *buffer, int buflen);
   void slotAddNewAlbum( void );
   void slot_onAlbumCreate( KIO::Job* job );
   void slotOverWriteModeActived( const QString &string );

 protected:
   QLabel                *m_labelOverWrite;
   QComboBox             *m_overWriteMode;
   QCheckBox             *m_removeOriginal;
   KListView             *m_listFiles;
   KProgress             *m_progress;
   QPushButton           *m_optionsButton;
   QLabel                *m_statusbar;
   QPushButton           *m_addNewAlbumButton;
   QComboBox             *m_albumList;

   int                    m_size;
   QString                m_resizeFilter;
   QString                m_newDir;

   int                    m_convertStatus;
   int                    m_progressStatus;
   KConfig               *m_config;
   QStringList            m_selectedImageFiles;
   int                    m_nbItem;
   KProcess              *m_convertProc;
   QListViewItemIterator *m_listFile2Process_iterator;

   void    listImageFiles(void);
   int     sortType(void);
   bool    startProcess(void);
   int     overwriteMode(void);
   void    endProcess(void);
   void    processAborted(void);
   QString RenameTargetImageFile(QFileInfo *fi);
   bool    ResizeImage( int &w, int &h, int SizeFactor);
};

#endif  // RESIZEIMAGESDIALOG_H
