//////////////////////////////////////////////////////////////////////////////
//
//    PLUGIN_FINDIMAGES.CPP
//
//    Copyright (C) 2004 Gilles CAULIER <caulier dot gilles at free.fr>
//    Copyright (C) 2004 Gregory Kokanosky <gregory dot kokanosky at free.fr>
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//////////////////////////////////////////////////////////////////////////////


// Include files for KDE

#include <klocale.h>
#include <kaction.h>
#include <kgenericfactory.h>
#include <klibloader.h>
#include <kconfig.h>
#include <kdebug.h>
#include <kmessagebox.h>

// Include files for Digikam

#include <digikam/albummanager.h>
#include <digikam/albuminfo.h>

// Local include files

#include "plugin_findimages.h"
#include "finddupplicateimages.h"

/////////////////////////////////////////////////////////////////////////////////////////////

K_EXPORT_COMPONENT_FACTORY( digikamplugin_findimages,
                            KGenericFactory<Plugin_FindImages>("digikam"));

Plugin_FindImages::Plugin_FindImages(QObject *parent, const char*, const QStringList&)
    : Digikam::Plugin(parent, "FindImages")
{
    setInstance(KGenericFactory<Plugin_FindImages>::instance());

    setXMLFile("plugins/digikamplugin_findimages.rc");

    KGlobal::locale()->insertCatalogue("digikamplugin_findimages");

    kdDebug() << "Plugin_FindImages plugin loaded" << endl;

    m_action_findImages = new KActionMenu(i18n("&Find images..."),
                           actionCollection(),
                           "findimages");

/*    m_action_findComments = new KAction(i18n("Find comments"),
                           "findcomments",
                           0,
                           this,
                           SLOT(slotFindComments()),
                           m_action_findImages,
                           "findcomments");*/

    m_action_findDuplicateImagesAlbums= new KAction(i18n("Find duplicate images"),
                           "finddupplicateimages",
                           0,
                           this,
                           SLOT(slotFindDuplicateImages()),
                           m_action_findImages,
                           "findduplicateimagesalbums");

    //m_action_findImages->insert(m_action_findComments);
    m_action_findImages->insert(m_action_findDuplicateImagesAlbums);
}


/////////////////////////////////////////////////////////////////////////////////////////////////////

Plugin_FindImages::~Plugin_FindImages()
{
}


/////////////////////////////////////////////////////////////////////////////////////////////////////

void Plugin_FindImages::slotFindComments()
{
    // TODO by Grgory Kokanosky

    KMessageBox::information(0, "Not yet implemented !!!");
}


/////////////////////////////////////////////////////////////////////////////////////////////////////

void Plugin_FindImages::slotFindDuplicateImages()
{
    FindDuplicateImages *findDuplicateOperation = new FindDuplicateImages(0);
    return;
}


